
// SAInstSDKUserSampleDlg.cpp : implementation file
//

#include "pch.h"
#include "framework.h"
#include "SAInstSDKUserSample.h"
#include "SAInstSDKUserSampleDlg.h"
#include "SAMessenger.h"
#include "afxdialogex.h"
//#include <memory>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CSAInstSDKUserSampleDlg dialog



CSAInstSDKUserSampleDlg::CSAInstSDKUserSampleDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_SAINSTSDKUSERSAMPLE_DIALOG, pParent)
	, sa(*new SAInstrument(*new SAMessenger))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSAInstSDKUserSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	DDX_Control(pDX, IDC_DOCKING_BUTTON, dockingButton);
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSAInstSDKUserSampleDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_LOGON, &CSAInstSDKUserSampleDlg::OnBnClickedButtonLogon)
	ON_BN_CLICKED(IDC_BUTTON_SEND_PT, &CSAInstSDKUserSampleDlg::OnBnClickedButtonSendPt)
	ON_BN_CLICKED(IDC_BUTTON_SEND_FRAME, &CSAInstSDKUserSampleDlg::OnBnClickedButtonSendFrame)
	ON_BN_CLICKED(IDC_BUTTON_SEND_CIRCLE, &CSAInstSDKUserSampleDlg::OnBnClickedButtonSendCircle)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_PROBE, &CSAInstSDKUserSampleDlg::OnBnClickedButtonRemoveProbe)
	ON_BN_CLICKED(IDC_BUTTON_SEND_MULTIPLE_FRAMES, &CSAInstSDKUserSampleDlg::OnBnClickedButtonSendMultipleFrames)
	ON_BN_CLICKED(IDC_BUTTON_SEND_PT_CLOUD, &CSAInstSDKUserSampleDlg::OnBnClickedButtonSendPtCloud)
	ON_BN_CLICKED(IDC_BUTTON_START_LINE_SCAN, &CSAInstSDKUserSampleDlg::OnBnClickedButtonStartLineScan)
	ON_BN_CLICKED(IDC_BUTTON_STOP_LINE_SCAN, &CSAInstSDKUserSampleDlg::OnBnClickedButtonStopLineScan)
	ON_BN_CLICKED(IDC_BUTTON_SEND_IJK_PT, &CSAInstSDKUserSampleDlg::OnBnClickedButtonSendIjkPt)
	ON_BN_CLICKED(IDC_BUTTON_SEND_MULTI_INST_XFORMS, &CSAInstSDKUserSampleDlg::OnBnClickedButtonSendMultiInstXforms)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_SEND_CMM_ARM_PT, &CSAInstSDKUserSampleDlg::OnBnClickedButtonSendCmmArmPt)
	ON_BN_CLICKED(IDC_BUTTON_SEND_IJK_PT_ARRAY, &CSAInstSDKUserSampleDlg::OnBnClickedButtonSendIjkPtArray)
END_MESSAGE_MAP()


// CSAInstSDKUserSampleDlg message handlers

BOOL CSAInstSDKUserSampleDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	CRect r;
	dockingButton.GetWindowRect(r);  // this is how we tell the sdk's docking control where to put the button - lets you visually place it
	ScreenToClient(&r); // be sure to call this - you want to send the relative coordinates of the top left corner of your invisible button
	sa.SetupDockingButton(this, r);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CSAInstSDKUserSampleDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if (!sa.OnDockWrapperCommand(*this, wParam, lParam))
	{
		CDialog::OnCommand(wParam, lParam);
	}

	return TRUE;
}

// Note the SignalInterfaceReady and SignalInterfaceFailed - SA needs to know IF you've enabled auto-connect via the GetAutoSock call
bool CSAInstSDKUserSampleDlg::Logon()
{
	if (sa.IsConnectedToSA()) // user very likely has already connected directly from SA
	{
		CString m;
		m.Format(_T("Interface is already connected to SA."));
		::MessageBox(NULL, m, _T("Already Connected"), MB_ICONINFORMATION | MB_SETFOREGROUND | MB_TOPMOST);

		return true;
	}

	bool ret = sa.Logon(212, "SAInstSDKSample"); // just an SA instrument index and a name, 212 is SAInstrumentSDK Photogrammetry, 213 is SAInstrumentSDK Photogrammetry2, 2 is original GSI VSTARS, 142 is Indoor GPS, 166 is Faro Arm 2.5m 6Dof QuantumS
											     // the name is used only for a settings file name, "SAInstSDK_%s_Settings.bin", where %s is the interfaceName entered here - this settings file is not currently in use, so the name does not yet matter
	if (ret)
	{
		sa.SetDistUnit(sa.du_in);	 // your native length units - just send everything in these units, and all data from SA (in your SAMessenger derivation) will also be in these units
									 // see distunits enum in Instrument.h
		sa.SignalInterfaceReady();
	}
	else
		sa.SignalInterfaceFailed();
	return ret;
}

void CSAInstSDKUserSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSAInstSDKUserSampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSAInstSDKUserSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSAInstSDKUserSampleDlg::OnBnClickedButtonLogon()
{
	// As of 2023.11, you can get rid of this button handler altogether
	// The only time it is useful at this point is if you see a reason to
	// allow your user to run your interface by double clicking your exe.
	// Otherwise, the user will always connect from SA, and the logon button
	// will not be necessary.
	Logon();
}

void CSAInstSDKUserSampleDlg::OnBnClickedButtonSendPt()
{
	// send a point to SA
	SAvector xyz;
	xyz.x = 20.5;
	xyz.y = 17;
	xyz.z = 5;

	SAvector sigma;
	sigma.x = 0.005;
	sigma.y = 0.01;
	sigma.z = 0.003;

	double radialOffset = 0.125;
	double planarOffset = 0.25;

	bool updateOnly = false;

	std::string target("p1");
	std::string group("Group1");

	std::vector<std::string> notes(4);
	notes[0] = "Here are some notes";
	notes[1] = "for this point";
	notes[2] = "that I sent";
	notes[3] = "just sigma here, not ijk or xform";

	sa.SendPointToSA(xyz, sigma, radialOffset, planarOffset, updateOnly, target, group, "", notes);
}

void CSAInstSDKUserSampleDlg::OnBnClickedButtonSendIjkPt() // IJK Uncertainty point - e.g. photogrammetry instruments
{
	// send an ijk point to SA
	SAvector xyz;
	xyz.x = -5.5;
	xyz.y = 17;
	xyz.z = 5;

	SAvector ijk;
	ijk.x = 0.0;
	ijk.y = 0.0;
	ijk.z = -1.0;

	SAvector sigma;
	sigma.x = 0.005;
	sigma.y = 0.01;
	sigma.z = 0.003;

	double radialOffset = 0.125;
	double planarOffset = 0.25;

	bool updateOnly = false;

	std::string target("pIJK1");
	std::string group("GroupIJK1");

	std::vector<std::string> notes(4);
	notes[0] = "Here are some notes";
	notes[1] = "for this point";
	notes[2] = "that I sent";
	notes[3] = "this one has ijk probe vector and sigma";

	sa.SendIJKUncertPointToSA(xyz, ijk, sigma, radialOffset, planarOffset, updateOnly, target, group, "", notes);
}

void CSAInstSDKUserSampleDlg::OnBnClickedButtonSendIjkPtArray()
{
	INT_PTR sz = 256;

	std::vector<SAvector> xyzs(sz);
	std::vector<SAvector> ijks(sz);
	std::vector<SAvector> sigmas(sz);
	std::vector<std::string> names(sz); // for SendIJKUncertPointWithNamesArrayToSA
	
	double radialOffset = 0.0;
	double planarOffset = 0.0;

	//std::string firstTarget("p1"); // for SendIJKUncertPointArrayToSA
	std::string group("Pts");
	std::string collection("");

	for (DWORD i = 0; i < sz; i++)
	{
		xyzs[i].x = -5.5 + double(i / 2);
		xyzs[i].y = 17 + double(i / 3);
		xyzs[i].z = 5;

		ijks[i].x = 0.0;
		ijks[i].y = 0.0;
		ijks[i].z = -1.0;

		sigmas[i].x = 0.005 + i * .0001;
		sigmas[i].y = 0.01;
		sigmas[i].z = 0.003;

 		// for SendIJKUncertPointWithNamesArrayToSA...
		if (i % 3 == 0)
		{
			names[i] = "SB";
			names[i].append(std::to_string(i));
		}
		else if (i % 2 == 0)
		{
			names[i] = "NUGGET";
			names[i].append(std::to_string(i));
		}
		else
		{
			names[i] = "CODE";
			names[i].append(std::to_string(i));
		}
	}

	// sa.SendIJKUncertPointArrayToSA(xyzs, ijks, sigmas, radialOffset, planarOffset, firstTarget, group, collection);
	sa.SendIJKUncertPointWithNamesArrayToSA(xyzs, ijks, sigmas, names, radialOffset, planarOffset, group, collection);
}

static int armMeasIterator = 0;
void CSAInstSDKUserSampleDlg::OnBnClickedButtonSendCmmArmPt()
{
	armMeasIterator++;

	bool updateOnly = false;
	bool sendJointValues = true;

	// the xyz and joint angles here will match the kinematics of a 2.5m 6dof Faro Quantum S arm

	// send a cmm arm point to SA
	SAvector xyz;
	xyz.x = -1.2;
	xyz.y = -27.4;
	xyz.z = 6.5;

	// send a frame to SA
	SAvector fixedXYZRotation;
	fixedXYZRotation.x = 0.0;
	fixedXYZRotation.y = 180.0;
	fixedXYZRotation.z = 0.0;

	SAxform t = sa.SetFromOriginAndFixedRxyzDegrees(xyz, fixedXYZRotation);

	double radialOffset = 0.125;
	double planarOffset = 0.25;

	size_t degreesOfFreedom = 6;
	std::vector<double> j(degreesOfFreedom);
	j[0] = 0.0;
	j[1] = 30.0;
	j[2] = 0.0;
	j[3] = 20.0;
	j[4] = 0.0;
	j[5] = 130.0;

	std::string target("pArm");
	target.append(std::to_string(armMeasIterator));
	std::string group("GroupArm1");

	std::vector<std::string> notes(4);
	notes[0] = "Here are some notes";
	notes[1] = "for this cmm arm point";
	notes[2] = "that I sent";
	notes[3] = "this one has probe xform and joint angles";

	sa.SendCMMPtToSA(xyz, t,  radialOffset, planarOffset, updateOnly, sendJointValues, j, target, group, "", notes);
}

static int frameMeasIterator = 0;
void CSAInstSDKUserSampleDlg::OnBnClickedButtonSendFrame()
{
	frameMeasIterator++;

	bool updateOnly = true;
	bool overWriteExisting = false;
	bool drawProbe = true;
	double rx = 10.0;
	double ry = -10.0;
	if (frameMeasIterator % 2 == 0)
	{
		rx = -10.0;
		ry = 10.0;
	}

	// send a frame to SA
	SAvector origin;
	origin.x = 22.5;
	origin.y = 18.0 + frameMeasIterator * 3;
	origin.z = 15.0 + frameMeasIterator * 1.5;

	SAvector fixedXYZRotation;
	fixedXYZRotation.x = rx;
	fixedXYZRotation.y = 180.0 + ry;
	fixedXYZRotation.z = 180.0;

	SAxform t = sa.SetFromOriginAndFixedRxyzDegrees(origin, fixedXYZRotation);

	std::string frameName("Aframe");
	//std::string collection("This is a Sample Collection");

	std::vector<std::string> notes(3);
	notes[0] = "Here are some notes";
	notes[1] = "for this frame";
	notes[2] = "that I sent";

	std::string collection = "";

	sa.SendFrameDataToSA(t, updateOnly, overWriteExisting, drawProbe, frameName, collection, notes);
}

void CSAInstSDKUserSampleDlg::OnBnClickedButtonSendCircle()
{
	// send a circle to SA
	SAvector circOrigin;
	circOrigin.x = 22.5;
	circOrigin.y = 19;
	circOrigin.z = 15;

	SAvector circFixedXYZRotation;
	circFixedXYZRotation.x = 3.0;
	circFixedXYZRotation.y = 2.0;
	circFixedXYZRotation.z = 30;

	SAxform circleT = sa.SetFromOriginAndFixedRxyzDegrees(circOrigin, circFixedXYZRotation);

	double radius = 4.0;

	std::vector<std::string> circNotes{ "This is a Circle", "That I sent", "To SA", "As a test." };

	sa.SendCircleToSA(circleT, radius, 360.0, "A Circle", "", circNotes);

	// also, send a report item to the Instrument History in SA
	std::string title("Sample Report Item");

	std::vector<std::string> bodyText(3);
	bodyText[0] = "This is a sample";
	bodyText[1] = "Inst History";
	bodyText[2] = "entry.";

	sa.SendInstrumentHistoryUpdate(title, bodyText, "");
}


void CSAInstSDKUserSampleDlg::OnBnClickedButtonRemoveProbe()
{
	sa.Remove6DTargetModel();
}

static int multiFramesIterator = 0;
void CSAInstSDKUserSampleDlg::OnBnClickedButtonSendMultipleFrames()
{
	multiFramesIterator++;

	bool updateOnly = false;
	bool overWriteExisting = true;
	bool drawProbe = true;

	//////////////////////////////////////////////////////////////////////////////
	// send CylFrame to SA
	double rx = 10.0;
	double ry = -10.0;
	if (multiFramesIterator % 2 == 0)
	{
		rx = -10.0;
		ry = 10.0;
	}

	SAvector origin;
	origin.x = 22.5;
	origin.y = 21.0 + multiFramesIterator * 3;
	origin.z = 16.5 + multiFramesIterator * 1.5;

	SAvector fixedXYZRotation;
	fixedXYZRotation.x = rx;
	fixedXYZRotation.y = 180.0 + ry;
	fixedXYZRotation.z = 180.0;

	SAxform t = sa.SetFromOriginAndFixedRxyzDegrees(origin, fixedXYZRotation);

	std::string frameName("CylFrame");
	//std::string collection("This is a Sample Collection");
	std::string collection = "";

	sa.SendFrameDataToSA(t, updateOnly, overWriteExisting, drawProbe, frameName, collection);

	//////////////////////////////////////////////////////////////////////////////
	// send SlotFrame to SA
	rx = 5.0;
	ry = -5.0;
	if (multiFramesIterator % 2 == 0)
	{
		rx = -15.0;
		ry = 15.0;
	}

	origin.x = -8.0;
	origin.y = 36.0 + multiFramesIterator * 3;
	origin.z = 9.0 + multiFramesIterator * 1.5;

	fixedXYZRotation.x = rx;
	fixedXYZRotation.y = 180.0 + ry;
	fixedXYZRotation.z = 180.0;

	t = sa.SetFromOriginAndFixedRxyzDegrees(origin, fixedXYZRotation);

	frameName = "SlotFrame";
	//std::string collection("This is a Sample Collection");
	collection = "";

	sa.SendFrameDataToSA(t, updateOnly, overWriteExisting, drawProbe, frameName, collection);

	//////////////////////////////////////////////////////////////////////////////
	// send TorusFrame to SA
	rx = -10.0;
	ry = 10.0;
	if (multiFramesIterator % 2 == 0)
	{
		rx = 5.0;
		ry = -5.0;
	}

	origin.x = -50.0;
	origin.y = 36.0 + multiFramesIterator * 3;
	origin.z = 6.0 + multiFramesIterator * 1.5;

	fixedXYZRotation.x = rx;
	fixedXYZRotation.y = 180.0 + ry;
	fixedXYZRotation.z = 270.0;

	t = sa.SetFromOriginAndFixedRxyzDegrees(origin, fixedXYZRotation);

	frameName = "TorusFrame";
	//std::string collection("This is a Sample Collection");
	collection = "";

	sa.SendFrameDataToSA(t, updateOnly, overWriteExisting, drawProbe, frameName, collection);
}

void CSAInstSDKUserSampleDlg::OnBnClickedButtonSendPtCloud()
{
	MakeAndSendAPointCloud();
}


void CSAInstSDKUserSampleDlg::OnBnClickedButtonStartLineScan()
{
	stopSimScanning = false;
	SimulateLineScan();
}


void CSAInstSDKUserSampleDlg::OnBnClickedButtonStopLineScan()
{
	stopSimScanning = true;
}

void CSAInstSDKUserSampleDlg::OnBnClickedButtonSendMultiInstXforms()
{
	// Send instrument xforms to SA - only for e.g. photogrammetry cameras or "indoor gps" transmitters, etc.

	size_t toSend = 3;
	std::vector<SAxform> camXform(toSend);
	std::vector<std::string> camName(toSend);
	std::vector<std::time_t> times(0);
	for (INT_PTR i = 0; i < toSend; i++)
	{
		SAvector pos{ -48.0 + (double)i * 48.0, (double)i * -12.0 - 36.0, (double)i + 18.0 };

		SAvector rot;
		rot.x = 3.0;
		rot.y = 1.5;
		rot.z = -15.0 + (double)i * 30.0;

		camXform[i] = sa.SetFromOriginAndFixedRxyzDegrees(pos, rot);

		camName[i] = "Cam ";
		camName[i].append(std::to_string(i));
	}
	sa.SendMultipleInstFramesToSA(camXform, camName, times);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
static int cloudScanIterator = -3;
void CSAInstSDKUserSampleDlg::MakeAndSendAPointCloud()
{
	INT_PTR pts = 256;

	//sa.SendOnScanPassStarted();
	std::vector<SAvector> cloud(pts);
	cloudScanIterator++;

	double shiftX = 5.0;
	double shiftY = 0.0;
	shiftX += cloudScanIterator * 20.0;

	for (DWORD k = 0; k < pts; k++)
	{
		cloud[k].x = shiftX + (15.0 * ((double)rand()) / ((double)RAND_MAX));
		cloud[k].y = shiftY + (double)(k) / 20.0 + (20.0 * ((double)rand()) / ((double)RAND_MAX));
		cloud[k].z = 0.5 + (double)((-1.0 * k) / k) * (0.01 * ((double)rand()) / ((double)RAND_MAX));
	}

	sa.SendPointCloudToSA(cloud, "SamplePointCloud", "C_oll");
	cloud.clear();
}

void CSAInstSDKUserSampleDlg::ProcessWaitingMessages()
{
	MSG msg;
	CWinApp* pApp = AfxGetApp();

	// clear out message queue (process any waiting messages)
	while (PeekMessage(&msg, m_hWnd, 0, 0, PM_REMOVE))
	{
		if ((pApp == NULL) || !pApp->PreTranslateMessage(&msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
}
void CSAInstSDKUserSampleDlg::Delay(double time, BOOL PWM)
{
	DWORD Start = ::GetTickCount();
	DWORD Delta = (DWORD)(time * 1000);		// convert to milliseconds.
	do
	{
		if (PWM)
			ProcessWaitingMessages();
		Sleep(10);		// jmc added to allow processor idle.
	} while ((::GetTickCount() - Start) < Delta);
}

static int scanLinesIterator = -3;
void CSAInstSDKUserSampleDlg::SimulateLineScan()
{
	INT_PTR ptsPerLine = 256;
	INT_PTR linesPerChunk = 300;
	INT_PTR linesPerSecond = 50;

	double shiftX = 5.0;
	double shiftY = 0.0;

	SAvector cPt;
	//sa.SendOnScanPassStarted();

	INT_PTR lineCtr = 0;
	INT_PTR ctr = 0;
	std::vector<SAScanStripe> cloud(linesPerChunk);

	scanLinesIterator++;

	while (1)
	{
		ProcessWaitingMessages();	// user needs to be able to abort meas

		if (stopSimScanning)
		{
			TRACE0("\n***Aborting SimulateLineScan***\n\n");
			//sa.SendOnScanPassStopped();
			return;
		}

		SAvector rot;
		rot.x = 180.0;
		rot.y = 0.0;
		rot.z = 0.0;

		double period = 1.0 / (double)linesPerSecond;
		Delay(period, TRUE);

		ctr = 0;
		shiftX += scanLinesIterator * 35.0;

		for (INT_PTR i = 0; i < linesPerChunk; i++)
		{
			lineCtr++;
			shiftX += 0.1;

			for (INT_PTR k = 0; k < ptsPerLine; k++)
			{
				++ctr;
				SAvector cPt;
				cPt.x = shiftX + (0.01 * ((double)rand()) / ((double)RAND_MAX));
				cPt.y = shiftY + (double)(k) / 50.0 + (1.0 * ((double)rand()) / ((double)RAND_MAX));
				cPt.z = 0.5 + (double)((-1.0 * ctr) / ctr) * (0.01 * ((double)rand()) / ((double)RAND_MAX));
				cloud[i].pts.push_back(cPt);

				if (k == ptsPerLine / 2)
				{
					cloud[i].scannerXform = sa.SetFromOriginAndFixedRxyzDegrees(cloud[i].pts[k], rot);
					//sa.SendFrameDataToSA(cloud[i].scannerXform, false, true, false, "frm");
				}
			}
		}

		shiftX = 5.0;
		shiftY += 6.0;
		//sa.SendOnScanPassStopped();
		//sa.SendOnScanPassStarted();
		sa.SendScanStripeCloudToSA(cloud, "SampleLineScanCloud");
		for (int j = 0; j < cloud.size(); j++)
			cloud[j].Clear();
	}
}
